// 아이디어
// 그리디 문제다
// 한번 사고 한번 파는것이 규칙이다.
// 오늘과 다음날 비교해서 오를꺼면 오늘 산다.
// 그리도 다음날 판다.
// 브루트포스로 접근하면
// 첫날사고, 둘째날 팔고, 셋쩨날 팔고 등의 모든 시나리오를 다 계산해야한다.
// 하지만 수익을 maximization 하려면,
// 수익을 계속 내는 것이 중요
// 따라서 쭉 오르는 흐름이여도,
// 첫날 사서 묵혀서 향후에 이득을 보는 형태가 아닌
// 이득을 볼때마다 산다.
// 현재의 이득을 취하는 전형적인 그리디
// 이는 현재의 이득을 취하는 것이 미래의 총이득에 포함되는 원소적 조건이기에
// 가능한 것이다. ==> 그리디가 가능한 이유
// 그리디 문제는 대부분 Maximazation 이 많이 나옴을 기억

var maxProfit = function (prices) {
  let sum = 0;
  let val = 0;
  for (let i = 0; i < prices.length - 1; ++i) {
    val = prices[i + 1] - prices[i];
    if (val > 0) sum += val;
  }

  return sum;
};
